The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# stk::Mandolin Class Reference

STK mandolin instrument model class. More...

`#include <Mandolin.h>`

Inheritance diagram for stk::Mandolin:

List of all members.

## Public Member Functions
| Mandolin (StkFloat lowestFrequency)
| Class constructor, taking the lowest desired playing frequency.
| ~Mandolin (void)
| Class destructor.
void | clear (void)
| Reset and clear all internal state.
void | setDetune (StkFloat detune)
| Detune the two strings by the given factor. A value of 1.0 produces unison strings.
void | setBodySize (StkFloat size)
| Set the body size (a value of 1.0 produces the "default" size).
void | setPluckPosition (StkFloat position)
| Set the pluck or "excitation" position along the string (0.0 - 1.0).
void | setFrequency (StkFloat frequency)
| Set instrument parameters for a particular frequency.
void | pluck (StkFloat amplitude)
| Pluck the strings with the given amplitude (0.0 - 1.0) using the current frequency.
void | pluck (StkFloat amplitude, StkFloat position)
| Pluck the strings with the given amplitude (0.0 - 1.0) and position (0.0 - 1.0).
void | noteOn (StkFloat frequency, StkFloat amplitude)
| Start a note with the given frequency and amplitude (0.0 - 1.0).
void | noteOff (StkFloat amplitude)
| Stop a note with the given amplitude (speed of decay).
void | controlChange (int number, StkFloat value)
| Perform the control change specified by number and value (0.0 - 128.0).
StkFloat | tick (unsigned int channel=0)
| Compute and return one output sample.
StkFrames & | tick (StkFrames &frames, unsigned int channel=0)
| Fill a channel of the StkFrames object with computed outputs.

## Detailed Description

STK mandolin instrument model class.

This class uses two "twang" models and "commuted synthesis" techniques to model a mandolin instrument.

This is a digital waveguide model, making its use possibly subject to patents held by Stanford University, Yamaha, and others. Commuted Synthesis, in particular, is covered by patents, granted, pending, and/or applied-for. All are assigned to the Board of Trustees, Stanford University. For information, contact the Office of Technology Licensing, Stanford University.

Control Change Numbers:

- Body Size = 2
- Pluck Position = 4
- String Sustain = 11
- String Detuning = 1
- Microphone Position = 128

by Perry R. Cook and Gary P. Scavone, 1995-2012.

## Member Function Documentation

StkFrames & stk::Mandolin::tick | ( | StkFrames & | frames,
|  | unsigned int | channel = `0` |
| ) |  |  | `[inline, virtual]`

Fill a channel of the StkFrames object with computed outputs.

The `channel` argument must be less than the number of channels in the StkFrames argument (the first channel is specified by 0). However, range checking is only performed if _STK_DEBUG_ is defined during compilation, in which case an out-of-range value will trigger an StkError exception.

Implements stk::Instrmnt.

    00115 {
    00116   unsigned int nChannels = lastFrame_.channels();
    00117 #if defined(_STK_DEBUG_)
    00118   if ( channel > frames.channels() - nChannels ) {
    00119     oStream_ << "Mandolin::tick(): channel and StkFrames arguments are incompatible!";
    00120     handleError( StkError::FUNCTION_ARGUMENT );
    00121   }
    00122 #endif
    00123
    00124   StkFloat *samples = &frames[channel];
    00125   unsigned int j, hop = frames.channels() - nChannels;
    00126   if ( nChannels == 1 ) {
    00127     for ( unsigned int i=0; i<frames.frames(); i++, samples += hop )
    00128       *samples++ = tick();
    00129   }
    00130   else {
    00131     for ( unsigned int i=0; i<frames.frames(); i++, samples += hop ) {
    00132       *samples++ = tick();
    00133       for ( j=1; j<nChannels; j++ )
    00134         *samples++ = lastFrame_[j];
    00135     }
    00136   }
    00137
    00138   return frames;
    00139 }

The documentation for this class was generated from the following file:

- Mandolin.h

The Synthesis ToolKit in C++ (STK)
©1995-2012 Perry R. Cook and Gary P. Scavone. All Rights Reserved.